<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
    "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">

<head>
<meta http-equiv="Content-Type"
    content="application/xhtml+xml; charset=utf-8" />
<title>Systematiki</title>
<style type="text/css" media="all">
    @import "./style/base.css";
</style>
</head>

<body>

<div class="box bhead">
<p style="float: right;">
    &lt; <a href="past/index.html">Past</a> &gt; &nbsp;
    &lt; <b>Present</b> &gt; &nbsp;
    &lt; <a href="future/index.html">Future</a> &gt; &nbsp;
</p>
<h1>Systematiki</h1>
</div>

<div class="box bside">
<p><a href="index.html">Introduction</a></p>
<p><a href="development.html">Development</a></p>
<p><a href="tutorial.html">Tutorial</a></p>
<p><a href="documentation.html">Documentation</a></p>
<p><a href="past-present.html">Past and Present</a></p>
</div>

<div class="box bmain">
<h2>The Big Picture</h2>
<p>This document describes some decisions I (Felix Rabe) took while
developing Systematiki.</p>

<p>Systematiki is a data-centric application with two big unknown variables:</p>

<h3>How the data will be stored (&quot;Back-end&quot;)</h3>
<p>The initial data storage is a dummy database that resides in memory and
contains example data.  This is quick and dirty and easy to implement.
Later, do we want data to be stored in a database
(like MySQL or PostgreSQL) or on the filesystem?
Systematiki should provide for both options.  Also, we'd like to have
transparent (TCP) network access to a remote server.</p>

<h3>How the data will be presented (&quot;Front-end&quot;)</h3>
<p>The possible uses of the data provided above should not be limited to
only one presentation / editor / GUI / whatever provided by the Systematiki
project.  The Systematiki code should provide for an editor GUI and a
(TCP) network server.</p>

<h3>The result</h3>
<p><i>(Also see the old
<a href="past/architecture.svg">architecture illustration</a>.)</i></p>
<p>Systematiki is divided into a front-end and a back-end, glued together
by <tt>systematiki.py</tt>.  All back-ends
share a common API such that all back-ends are usable with all front-ends
(and vice versa).</p>

<h2>Glossary</h2>
<p><i>(Also see the old
<a href="past/prototype-2.html">proto2 glossary</a>.)</i></p>
<p><b>API</b><br/>
Application Programming Interface.  The back-ends have a common API.</p>
<p><b>Back-end</b><br/>
A software module that retrieves and stores data in some kind of a database,
e.g. MySQL, filesystem, or TCP network.</p>
<p><b>Front-end</b><br/>
A software module that makes back-end data available to either the user or
another application, e.g. over the network.</p>

<h2>Systematiki and Python</h2>
<p>Systematiki (including front-end and back-end) is implemented in Python.
The front-end/back-end split means that one or both of those ends can
interact with (bind to) another programming language.  Where this is not
possible, Systematiki can always be accessed over the network or by other
IPC mechanisms, limited only by what people cared to implement.</p>

<h2>Configuring Systematiki</h2>
<p><i>(Also see the old
<a href="past/server-configuration.html">server configuration</a>
proposal.)</i></p>
<p><tt>systematiki.py</tt> can <i>only</i> be configured using command-line
arguments.  Other means of configuration (GUI, configuration files) can
be provided later with external wrapper scripts / programs.</p>
</div>

<div class="box bfoot">
<p>Software for browsing, searching, and editing semantically linked data.</p>
</div>

</body>

</html>

